# YouTube视频下载器 - 泥人传说版

**作者：泥人传说**  
**作者地址：https://nirenchuanshuo.com**

## 📋 软件简介

这是一个功能强大的YouTube视频下载器，支持多种格式和质量选择，具有现代化的用户界面和批量下载功能。

## 🚀 快速开始

### 启动软件选择

项目提供了三个不同的启动脚本，请根据需要选择：

#### 🎨 启动泥人传说版V2.1.bat（强烈推荐）
- **程序**：`youtube_beautiful_fixed.py`
- **特点**：现代化美化界面，功能最完整
- **适用**：日常使用，追求最佳用户体验
- **界面**：现代化设计，支持队列管理、实时进度显示
- **功能**：完整的下载功能 + 加密保护 + 美化界面

#### 📱 启动泥人传说版V2.1基础版.bat
- **程序**：`main.py`
- **特点**：简洁界面，资源占用少
- **适用**：低配置电脑，追求简洁高效
- **界面**：传统界面设计，操作简单直观
- **功能**：核心下载功能 + 加密保护

#### 🔧 启动泥人传说版.bat（兼容版）
- **程序**：`youtube_beautiful_fixed.py`
- **特点**：保持原有启动方式，向后兼容
- **适用**：习惯原版操作的用户
- **界面**：与V2.1版相同的美化界面
- **功能**：完整功能，保持兼容性

### 命令行启动
- 美化版：`python youtube_beautiful_fixed.py`
- 基础版：`python main.py`

## 🔍 启动脚本详细说明

### 启动脚本内容对比

#### 🎨 启动泥人传说版V2.1.bat
```batch
title YouTube视频下载器 - 泥人传说版 V2.1
echo 🎨 现代化界面设计 (泥人传说版)
echo 🔒 核心代码已加密保护
echo 🛡️ 作者信息防篡改保护
echo 📅 版本：V2.1
python youtube_beautiful_fixed.py
```

#### 📱 启动泥人传说版V2.1基础版.bat
```batch
title YouTube视频下载器 - 泥人传说版 V2.1 基础版
echo 🎯 简洁界面设计 (泥人传说基础版)
echo 🔒 核心代码已加密保护
echo 🛡️ 作者信息防篡改保护
echo 📅 版本：V2.1
python main.py
```

#### 🔧 启动泥人传说版.bat
```batch
title YouTube视频下载器 - 泥人传说版
echo 🎨 现代化界面设计 (修复版)
echo 🚀 功能完整，下载稳定
echo 🔧 修复了样式兼容性问题
python youtube_beautiful_fixed.py
```

### 启动脚本特点

| 特点 | V2.1美化版 | V2.1基础版 | 兼容版 |
|------|-----------|-----------|--------|
| **窗口标题** | 泥人传说版 V2.1 | 泥人传说版 V2.1 基础版 | 泥人传说版 |
| **版本标识** | V2.1 | V2.1 | 修复版 |
| **错误处理** | ✅ 完整 | ✅ 完整 | ✅ 完整 |
| **依赖检查** | ✅ 自动提示 | ✅ 自动提示 | ✅ 自动提示 |
| **编码支持** | ✅ UTF-8 | ✅ UTF-8 | ✅ UTF-8 |

## 📖 详细使用说明

### 1. 基本下载流程

**重要提示：必须先添加到下载队列才能下载！**

1. **粘贴视频链接**
   - 在"下载链接"输入框中粘贴YouTube视频URL
   - 支持的链接格式：
     - 普通视频：`https://www.youtube.com/watch?v=...`
     - 短链接：`https://youtu.be/...`
     - YouTube Shorts：`https://www.youtube.com/shorts/...`
     - 播放列表：`https://www.youtube.com/playlist?list=...`

2. **选择下载设置**
   - 选择视频质量（144p - 2160p）
   - 选择输出格式（MP4, WebM, MKV, MP3, M4A, WAV）
   - 选择保存路径（可点击"浏览"按钮更改）

3. **添加到下载队列**
   - **必须点击"➕ 添加到队列"按钮**
   - 视频链接会被添加到下载列表中
   - 输入框会自动清空，可继续添加其他视频

4. **开始下载**
   - 点击"🚀 开始下载"按钮
   - 系统会按顺序下载队列中的所有视频

### 2. 队列管理功能

#### 添加视频到队列
- 输入视频链接后，点击"➕ 添加到队列"
- 每个视频可以设置不同的质量和格式
- 重复链接会被自动识别并提示

#### 重新下载功能
- 在下载队列中选中要重新下载的视频
- 点击"🔄 重新下载"按钮
- 适用于下载失败或需要重新下载的情况

#### 清空队列
- 点击"🗑️ 清空队列"按钮清空所有待下载项目
- 下载进行中时无法清空队列

### 3. 下载状态说明

- ⏳ **等待中**：视频已添加到队列，等待下载
- ⬇️ **下载中**：正在下载该视频
- ✅ **完成**：下载成功完成
- ❌ **失败**：下载失败，可使用重新下载功能

### 4. 特殊功能

#### 视频信息获取
- 粘贴链接后按回车键或点击获取信息
- 显示视频标题、作者、时长、观看次数等信息

#### 封面下载
- 勾选"下载封面"选项
- 会同时下载视频缩略图

#### 并发下载
- 可设置并发线程数（1-6个）
- 提高下载速度，但会增加系统负载

## ⚠️ 重要注意事项

### 下载流程要求
1. **不能直接点击下载**：将视频链接粘贴到输入框后，不能直接点击"开始下载"
2. **必须先添加到队列**：必须先点击"添加到队列"按钮
3. **队列管理**：已下载成功的视频不会重复下载，除非使用"重新下载"功能

### YouTube Shorts支持
- 完全支持YouTube短视频下载
- 使用优化的格式选择器，提高成功率
- 自动处理不同的视频格式和质量

### 文件保存
- 默认保存到 `downloads` 文件夹
- 可通过"浏览"按钮更改保存路径
- 点击"打开文件夹"快速访问下载目录

## 🔧 技术特性

### 支持的格式
- **视频格式**：MP4, WebM, MKV
- **音频格式**：MP3, M4A, WAV
- **视频质量**：144p, 240p, 360p, 480p, 720p, 1080p, 1440p, 2160p

### 高级功能
- 自动音视频合并
- 多线程并发下载
- 实时进度显示
- 详细日志记录
- 错误重试机制

### 🔒 泥人传说版V2.1安全特性
- **核心代码加密保护**：下载核心逻辑已加密处理，防止恶意篡改
- **作者信息加密**：作者信息和网站地址采用高强度加密保护
- **防篡改机制**：关键信息无法被轻易修改或伪造
- **加密算法**：采用AES-256加密和PBKDF2密钥派生
- **安全启动**：启动脚本包含完整性检查
- **三重保护**：美化版、基础版、兼容版均具备完整加密保护

## 🐛 常见问题

### 下载失败怎么办？
1. 检查网络连接
2. 确认视频链接有效
3. 尝试更换视频质量
4. 使用"重新下载"功能

### 为什么点击下载没反应？
- 确保已将视频添加到下载队列
- 检查队列中是否有待下载项目
- 查看日志信息了解具体原因

### YouTube Shorts下载失败？
- 软件已优化对Shorts的支持
- 如仍有问题，尝试选择较低质量
- 检查链接格式是否正确

## 📞 技术支持

如遇到问题，请查看软件日志区域的详细信息，或检查以下文件：
- `downloads/` - 下载文件目录
- `bin/` - 依赖程序目录
- 日志信息会实时显示在软件界面中

---

**版本信息**：泥人传说版 V2.1 (加密保护版)  
**更新日期**：2025年最新版  
**兼容系统**：Windows 7/8/10/11  
**作者信息**：[加密保护，防止篡改]  
**网站信息**：[加密保护，防止篡改]

## 🎯 项目简介

这是一个功能完整的YouTube视频下载器，支持多种视频质量和格式，具有现代化的图形界面。

## 📦 版本详细对比

### 功能对比表

| 功能特性 | 美化版V2.1 | 基础版V2.1 | 兼容版 |
|---------|-----------|-----------|--------|
| **启动脚本** | `启动泥人传说版V2.1.bat` | `启动泥人传说版V2.1基础版.bat` | `启动泥人传说版.bat` |
| **主程序** | `youtube_beautiful_fixed.py` | `main.py` | `youtube_beautiful_fixed.py` |
| **界面设计** | ✅ 现代化美化界面 | ⚡ 传统简洁界面 | ✅ 现代化美化界面 |
| **队列管理** | ✅ 完整队列功能 | ❌ 单个下载 | ✅ 完整队列功能 |
| **批量下载** | ✅ 支持 | ❌ 不支持 | ✅ 支持 |
| **实时进度** | ✅ 详细进度显示 | ✅ 基础进度显示 | ✅ 详细进度显示 |
| **加密保护** | ✅ 完整加密 | ✅ 完整加密 | ✅ 完整加密 |
| **资源占用** | 🔶 中等 | ✅ 较低 | 🔶 中等 |
| **启动速度** | 🔶 中等 | ✅ 较快 | 🔶 中等 |
| **兼容性** | ✅ 最新版本 | ✅ 最新版本 | ✅ 向后兼容 |

### 选择建议

#### 🎯 推荐用户群体

**美化版V2.1** - 适合以下用户：
- 日常频繁使用YouTube下载
- 需要批量下载多个视频
- 追求现代化用户体验
- 电脑配置中等以上

**基础版V2.1** - 适合以下用户：
- 偶尔使用，单个视频下载
- 电脑配置较低或追求极简
- 喜欢传统界面风格
- 注重启动速度和资源占用

**兼容版** - 适合以下用户：
- 从旧版本升级的用户
- 习惯原有操作方式
- 需要保持操作习惯一致性
- 临时使用或测试

## 💡 使用技巧

### 快捷键
- `Ctrl+V`: 快速粘贴YouTube链接
- `Enter`: 在URL输入框中按回车获取视频信息

### 下载优化
- 建议并发数设置为3-4个
- 选择合适的视频质量以平衡文件大小和质量
- 使用MP4格式获得最佳兼容性

### 批量下载
1. 输入第一个视频链接
2. 点击"添加到队列"
3. 重复添加更多视频
4. 点击"开始下载"批量处理

## 🔧 系统要求

- **操作系统**: Windows 7/8/10/11
- **Python**: 3.7+ (自动检测)
- **网络**: 稳定的互联网连接

## 📁 文件结构

```
YT_Videos_Download/
├── bin/                          # 依赖程序
│   ├── yt-dlp.exe               # YouTube下载核心
│   └── ffmpeg.exe               # 音视频处理
├── downloads/                   # 默认下载目录
├── youtube_beautiful_fixed.py   # 泥人传说版V2.1美化版主程序 (推荐)
├── main.py                      # 泥人传说版V2.1基础版主程序
├── config.py                    # 配置文件
├── utils.py                     # 工具函数
├── crypto_utils.py              # 🔒 加密工具模块 (新增)
├── download_core.py             # 🔒 加密下载核心 (新增)
├── 启动泥人传说版V2.1.bat       # 泥人传说版V2.1美化版启动脚本 (推荐)
├── 启动泥人传说版V2.1基础版.bat # 泥人传说版V2.1基础版启动脚本
├── 启动泥人传说版.bat           # 原版兼容启动脚本
├── requirements.txt             # Python依赖 (已更新)
├── LICENSE                      # 许可证
├── README.md                    # 项目说明
└── 使用说明.md                  # 详细使用说明 (已更新)
```

## 🆘 技术支持

如果遇到问题：
1. 查看日志输出了解错误信息
2. 确保使用最新版本的程序
3. 检查网络连接和YouTube链接有效性

## 🌟 快速选择指南

### 🎯 根据使用场景选择

#### 💼 日常工作使用
**推荐**: 美化版V2.1
- 功能完整，支持批量下载
- 现代化界面，操作效率高
- 队列管理，适合处理多个视频

#### 🏠 家庭偶尔使用
**推荐**: 基础版V2.1
- 界面简洁，操作简单
- 资源占用少，启动快速
- 满足基本下载需求

#### 🔄 从旧版升级
**推荐**: 兼容版
- 保持原有操作习惯
- 平滑过渡到新版本
- 功能与美化版相同

### 📊 性能对比

| 版本 | 内存占用 | 启动时间 | 功能完整度 | 推荐指数 |
|------|---------|---------|-----------|----------|
| 美化版V2.1 | ~50MB | 3-5秒 | ⭐⭐⭐⭐⭐ | ⭐⭐⭐⭐⭐ |
| 基础版V2.1 | ~30MB | 1-2秒 | ⭐⭐⭐⭐ | ⭐⭐⭐⭐ |
| 兼容版 | ~50MB | 3-5秒 | ⭐⭐⭐⭐⭐ | ⭐⭐⭐ |

## 📄 许可证

本项目采用MIT许可证，详见 `LICENSE` 文件。

---

**享受下载！** 🎉 